//! Define Macro using widely
/*!
* Author comment : Macro define
*
* Author : Alex 23rd.
*
* Filename : macro.h
*
* Contents : including macro
*
* Date : 2005-02-27
*
* Version : v0.2
*
* This program belong to Inha University Robot Research.
* Non permitted commercial use is highly prohibited.
*
* Modification :
* 2005-02-02 first implementation
* 2005-02-27 Version Up. (change nothing)
* 2005-02-27 sbi,cbi macro updated.
*
*/
#ifndef _MACRO_H_
#define _MACRO_H_

#define PUBLIC
#define PRIVATE static

// Argument x means SOURCE, y means VALUE
#define sbi(x,y)    (x |= (1<<y))
#define cbi(x,y)    (x &= ~(1<<y))

#define outp(x,y)   y=x
#define inp(x)      x

#define setbit(ADDRESS,BIT)	(ADDRESS |= (1<<BIT))
#define clearbit(ADDRESS,BIT)	(ADDRESS &= ~(1<<BIT))
#define checkbit(ADDRESS,BIT)	(ADDRESS&(1<<BIT))

#endif
