/**
 * Filename		: ps2pad_btnctl.c
 * PS2 Pad Button Controller
 * Author	 : Hyun sik, Kim
 * Company	 : HURO(Robot research in inha univ.)
 * Last Update : 2005. 3. 8
 * Description :
 *   Button controller
 *   for Robot Control
 */

#include <avr/io.h>
#include "ps2pad_btnctl.h"
#include "macro.h"
#include "configure.h"

PUBLIC tagPSXBUTTON
psxScanButton(void)
{
	tagPSXBUTTON status;
	
    cbi(PORT_PSXPORT, PSX_ATT);   //attention low(Active)
    
    psxData(0x01);				// Start Condition
    psxData(0x42);				// return value : Controller ID
    psxData(0x00);    			// return value : 0x5a
    status.btn1.data = ~psxData(0x00); // SLCT JOYR JOYL STRT UP   RGHT DOWN LEFT
    status.btn2.data = ~psxData(0x00); // L2   R2   L1   R1   /\   O    X    |_|
    status.RjoyLR = psxData(0x00);     // Right Joy 0x00 = Left  0xFF = Right
    status.RjoyUD = psxData(0x00);     // Right Joy 0x00 = Up    0xFF = Down
    status.LjoyLR = psxData(0x00);     // Left Joy  0x00 = Left  0xFF = Right
    status.RjoyUD = psxData(0x00);     // Left Joy  0x00 = Up    0xFF = Down
    
    sbi(PORT_PSXPORT, PSX_ATT);   //attention hi(Inactive)
	
	return status;
}
