/**
 * Filename		: ps2pad_btnctl.h
 * PS2 Pad Button Controller
 * Author	 : Hyun sik, Kim
 * Company	 : HURO(Robot research in inha univ.)
 * Last Update : 2005. 3. 8
 * Description :
 *   Button controller
 *   for Robot Control
 */

#ifndef _PS2PAD_BTNCTL_H_
#define _PS2PAD_BTNCTL_H_

#include "macro.h"
#include "typedef.h"

typedef struct {
	u08 select	: 1; // bit0
	u08 joyr	: 1; // bit1
	u08 joyl	: 1; // bit2
	u08 start	: 1; // bit3
	u08 up		: 1; // bit4
	u08 right	: 1; // bit5
	u08 down	: 1; // bit6
	u08 left	: 1; // bit7
	} tagBUTTONDATABITS1;

typedef union {
	u08 data;
	tagBUTTONDATABITS1 bits;
	} tagBUTTONDATA1;
	
typedef struct {
	u08 l2		: 1;  // bit0
	u08 r2		: 1;  // bit1
	u08 l1		: 1;  // bit2
	u08 r1		: 1;  // bit3
	u08 tri		: 1;  // bit4
	u08 cir		: 1;  // bit5
	u08 x		: 1;  // bit6
	u08 sq		: 1;  // bit7
	} tagBUTTONDATABITS2;

typedef union {
	u08 data;
	tagBUTTONDATABITS2 bits;
	} tagBUTTONDATA2;
	 
typedef struct {
	tagBUTTONDATA1 btn1;
	tagBUTTONDATA2 btn2;
	u08 RjoyLR;				// 0x00 <-- L R --> 0xFF
	u08 RjoyUD;				// 0x00 <-- U D --> 0xFF
	u08 LjoyLR;				// 0x00 <-- L R --> 0xFF
	u08 LjoyUD;				// 0x00 <-- U D --> 0xFF
	} tagPSXBUTTON;

PUBLIC tagPSXBUTTON psxScanButton(void);

#endif // _PS2PAD_BTNCTL_H_
