/**
 * Filename : ps2pad_lib.c
 * Title	: Playstation2 Analog pad driver
 * Author	 : Hyun, Im (Alex)
 * Company	 : HURO(Robot research in inha univ.)
 * Last Update : 2005. 3. 8
 * Description :
 *   Playstation2 Analog Joypad(Red mode) driver
 *   for ATMega128(AVR)
 */


#include <avr/io.h>

#include "configure.h"
#include "ps2pad_lib.h"
#include "macro.h"
#include "typedef.h"

PUBLIC void
psxInitPort(void)
{
    cbi(DDR_PSXPORT, PSX_DATA);		// as input (DATA)
    sbi(DDR_PSXPORT, PSX_COMMAND);		// as Output (Command)
    sbi(DDR_PSXPORT, PSX_ATT);			// as Output (ATT)
    sbi(DDR_PSXPORT, PSX_CLOCK);		// as Output (CLOCK)
    cbi(DDR_PSXPORT, PSX_ACK);			// as Input (ACK)
}

PUBLIC u08
psxData(u08 data)
{
    u08 recvByte = 0x00;
    u08 i;
    
    for(i = 0; i < 8; i++)
    {
        //Clock Low
        cbi(PORT_PSXPORT, PSX_CLOCK);
        
        if( ( data & ( 1 << i ) ) == 1)
        {
            sbi(PORT_PSXPORT, PSX_COMMAND);
        }
        else // if( ( data & (1 << i) ) == 0)
        {
            cbi(PORT_PSXPORT, PSX_COMMAND);
        }
        
        //Clock Hi
        sbi(PORT_PSXPORT, PSX_CLOCK);
        
        recvByte |= ( ( PIN_PSXPORT & ( 1 << PSX_DATA ) ) << i );
    }
    
    return recvByte;
}

