//! Printf underbar header file.
/*!
* Author comment : Printf Library Header
*
* Author : Alex 23rd.
*
* Filename : printf_.h
*
* Contents : Atmega128 Printf- library using uart header.
*
* Date : 2005-02-27
*
* Version : v0.1
*
* This program belong to Inha University Robot Research.
* Non permitted commercial use is highly prohibited.
*
* Modification :
* 2005-02-27 first implementation
*
*/

#ifndef _PRINTF_H_
#define _PRINTF_H_

#include <avr/pgmspace.h>

#include "typedef.h"
#include "macro.h"
#include "uart.h"

#ifndef TRUE
	#define TRUE	-1
	#define FALSE	0
#endif

#define INF     32766	// maximum field size to print

#define PRINTF_COMPLEX
//#define PRINTF_SIMPLE

#define STRING_IN_RAM	0
#define STRING_IN_ROM	1

//Function Prototype
u08 Isdigit(s08 c);
s16 atoiRamRom(u08 stringInRom, s08 *str);

#ifdef  PRINTF_SIMPLE
    int printfRamRom(u08 stringInRom,const s08* formatstr,...);
    #define printf_(format, args...)    printfRamRom(STRING_IN_ROM,PSTR(format), ## args)
#endif

#ifdef  PRINTF_COMPLEX
    int printfRamRom(u08 stringInRom,const s08* formatstr,...);
    #define printf_(format, args...)    printfRamRom(STRING_IN_ROM,PSTR(format), ## args)
#endif

inline void rprintfChar(u08 c);

#endif
