//! ATmega128 Uart Library Header
/*!
* Author comment : uart header file
*
* Author : alex 23rd
*
* Filename : uart.h
*
* Contents : uart related function header
*
* Date : 2005-02-27
*
* Version : v0.2
*
* This program belong to Inha University Robot Research.
* Non permitted commercial use is highly prohibited.
*
* Modification :
* 2005-02-02 first implementation
* 2005-02-27 Seperate UART0,1 Related Functions
*
*/


#ifndef _UART_H_
#define _UART_H_

#define F_CPU 14745600

//#define _DEBUG_UART_

#ifdef  _DEBUG_UART_
#include "library/printf_.h"
#endif

#include "typedef.h"
#include "macro.h"

PUBLIC void uart0_init(u32);
PUBLIC void uart1_init(u32);

PRIVATE u08 uart0_recv(void);
PRIVATE u08 uart1_recv(void);

PRIVATE void uart0_send(unsigned char data);
PRIVATE void uart1_send(unsigned char data);

PUBLIC u08 getch_(u08);

PUBLIC u08 getche_(u08);

PUBLIC void putchar_(u08,u08);

PUBLIC void puts_(u08,u08*);

//PUBLIC void puthex_(u08,u32);
//PUBLIC void printhex_(u08 value);
//PUBLIC void putdec_(u08,u32);

#endif
